﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace howto_treeview_list_checked
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            trvMeals.ExpandAll();
        }

        // List the checked TreeNodes.
        private void btnShowChecked_Click(object sender, EventArgs e)
        {
            // Get the checked nodes.
            List<TreeNode> checked_nodes = CheckedNodes(trvMeals);

            // Display the checked nodes.
            string results = "";
            foreach (TreeNode node in checked_nodes)
                results += node.Text + "\n";
            MessageBox.Show(results);
        }

        // Return a list of the checked TreeView nodes.
        private List<TreeNode> CheckedNodes(TreeView trv)
        {
            List<TreeNode> checked_nodes = new List<TreeNode>();
            FindCheckedNodes(checked_nodes, trvMeals.Nodes);
            return checked_nodes;
        }

        // Return a list of the TreeNodes that are checked.
        private void FindCheckedNodes(List<TreeNode> checked_nodes, TreeNodeCollection nodes)
        {
            foreach (TreeNode node in nodes)
            {
                // Add this node.
                if (node.Checked) checked_nodes.Add(node);

                // Check the node's descendants.
                FindCheckedNodes(checked_nodes, node.Nodes);
            }
        }
    }
}
